//                                                          TRIANGLES Lines+Fibo HL SDV+
//______________________________________________________________________________________

#property description " * * * * * * "
#property description " 1.09.16   .   "


#property indicator_chart_window
#property strict
#define   pref "+SDV_TRIANGLES_"

input bool              ShowRomb = TRUE;         // 
input bool         ShowRectangle = TRUE;         // 
input bool         ShowPitchfork = TRUE;         // 
input bool              ShowFibo = TRUE;         // 
extern int       BrokerTimeShift = 0;            //  
extern ENUM_TIMEFRAMES TimeFrame = PERIOD_H1;    //  
extern bool          ShadowShift = false;        //     
extern int        TrianglesCount = 72;           //    
input color            ColorRomb = clrSlateBlue; //  
input color       ColorRectangle = clrKhaki;     //  
input color     ColorPitchforkUP = clrRed;       //   
input color     ColorPitchforkDN = clrBlue;       //   
input ENUM_LINE_STYLE  InpStyle  = STYLE_SOLID;  //   
input int         PitchforkWidth = 1;            //   
input color            ColorFibo = clrBlack;   //   
input ENUM_LINE_STYLE  FiboStyle = STYLE_DOT;    //   
input bool                FiboUP = false;        //  

input string copy      = "3";

int init() {
   if (TimeFrame<=_Period) TimeFrame=_Period;
   if (BrokerTimeShift<0) BrokerTimeShift=0;
   if (TrianglesCount<1) TrianglesCount=1;
   
   return(0);
}


int deinit() {
   TRIANGLES_delete();

   return(0);
}


void TRIANGLES_delete() {
   string name;
   for (int s=ObjectsTotal()-1; s>=0; s--) {
      name=ObjectName(s);
      if (StringSubstr(name,0,StringLen(pref))==pref) ObjectDelete(name);
   }
}


int start() {
   double HighPrice = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,TrianglesCount,BrokerTimeShift+1));
   double LowPrice  = iLow(NULL,TimeFrame,iLowest(NULL,TimeFrame,MODE_LOW,TrianglesCount,BrokerTimeShift+1));
   double MidPrice  = NormalizeDouble((HighPrice+LowPrice)/2,Digits);
   
   int ShadowEnd=0;
   int realBrokerTimeShift=BrokerTimeShift;
   int realTrianglesCount=TrianglesCount;
   if (ShadowShift) {
      BrokerTimeShift=0;
      TrianglesCount=0;
      ShadowEnd=TimeFrame;
      MidPrice=iOpen(NULL,TimeFrame,0);
      double range=(HighPrice-LowPrice)/2;
      HighPrice=MidPrice+range;
      LowPrice=MidPrice-range;
   }
   
   if (ShowRectangle) {
      DrawRECTANGLE (copy+"Rectangle_"+TimeFrame+"_"+BrokerTimeShift+"_", 
      iTime(NULL,TimeFrame,TrianglesCount+BrokerTimeShift), HighPrice, 
      iTime(NULL,TimeFrame,BrokerTimeShift)+ShadowEnd*60, LowPrice, ColorRectangle);
   }
      
   if (ShowPitchfork) {
      DrawPITCHFORK(copy+"Pitchfork_"+TimeFrame+"_"+BrokerTimeShift+"_", 
      iTime(NULL,TimeFrame,TrianglesCount+BrokerTimeShift), 
      iTime(NULL,TimeFrame,BrokerTimeShift)-TimeFrame*TrianglesCount/2*60+ShadowEnd*60/2, HighPrice, 
      iTime(NULL,TimeFrame,BrokerTimeShift)-TimeFrame*TrianglesCount/2*60+ShadowEnd*60/2, LowPrice);
   }
      
   if (ShowFibo) {
      DrawFIBO(copy+"Fibo_"+TimeFrame+"_"+BrokerTimeShift+"_", 
      iTime(NULL,TimeFrame,TrianglesCount+BrokerTimeShift),
      HighPrice, LowPrice);
   }
      
   if (ShowRomb) {
      DrawRomb (copy+"Romb_"+TimeFrame+"_"+BrokerTimeShift+"_", 
      iTime(NULL,TimeFrame,TrianglesCount+BrokerTimeShift), MidPrice, 
      iTime(NULL,TimeFrame,BrokerTimeShift)-TimeFrame*TrianglesCount/2*60+ShadowEnd*60/2, HighPrice, 
      iTime(NULL,TimeFrame,BrokerTimeShift)-TimeFrame*TrianglesCount/2*60+ShadowEnd*60/2, LowPrice,
      iTime(NULL,TimeFrame,BrokerTimeShift)+ShadowEnd*60,
      ColorRomb);
   }
   
   BrokerTimeShift=realBrokerTimeShift;
   TrianglesCount=realTrianglesCount;

   return(0);
}


void DrawRECTANGLE(string Name, datetime T2, double P2, datetime T1, double P1,  color C) {
   ObjectDelete(pref+Name);
   ObjectCreate(pref+Name, OBJ_RECTANGLE, 0, T2,P2,T1,P1);
   ObjectSet   (pref+Name, OBJPROP_STYLE, 0);
   ObjectSet   (pref+Name, OBJPROP_COLOR, C);
   ObjectSet   (pref+Name, OBJPROP_BACK, true);
}


void DrawRomb(string Name, datetime T3, double P3, datetime T2, double P2, datetime T1, double P1, datetime T4, color C) {
   ObjectDelete(pref+Name);
   ObjectCreate(pref+Name, OBJ_TRIANGLE, 0, T3,P3,T2,P2,T1,P1);
   ObjectSet   (pref+Name, OBJPROP_COLOR, C);
   ObjectSet   (pref+Name, OBJPROP_BACK, true);
   
   ObjectDelete(pref+Name+1);
   ObjectCreate(pref+Name+1, OBJ_TRIANGLE, 0, T4,P3,T2,P2,T1,P1);
   ObjectSet   (pref+Name+1, OBJPROP_COLOR, C);
   ObjectSet   (pref+Name+1, OBJPROP_BACK, true);
}


void DrawPITCHFORK(string Name, datetime T3, datetime T2, double P2, datetime T1, double P1) {
   ObjectDelete(pref+Name);
   ObjectCreate(pref+Name, OBJ_PITCHFORK, 0, T3,P1,T2,P2,T1,P1);
   ObjectSet   (pref+Name, OBJPROP_COLOR, ColorPitchforkUP);
   ObjectSet   (pref+Name, OBJPROP_BACK, true);
   ObjectSet   (pref+Name, OBJPROP_WIDTH, PitchforkWidth);
   ObjectSet   (pref+Name, OBJPROP_STYLE, InpStyle);
   
   ObjectDelete(pref+Name+1);
   ObjectCreate(pref+Name+1, OBJ_PITCHFORK, 0, T3,P2,T2,P1,T1,P2);
   ObjectSet   (pref+Name+1, OBJPROP_COLOR, ColorPitchforkDN);
   ObjectSet   (pref+Name+1, OBJPROP_BACK, true);
   ObjectSet   (pref+Name+1, OBJPROP_WIDTH, PitchforkWidth);
   ObjectSet   (pref+Name+1, OBJPROP_STYLE, InpStyle);
}


void DrawFIBO(string Name, datetime T3, double P2, double P1) {
   ObjectDelete(pref+Name);
   if (!FiboUP) {if(!ObjectCreate(0,pref+Name,OBJ_FIBO,0,T3,P1,T3,P2)) return;}
   else if(!ObjectCreate(0,pref+Name,OBJ_FIBO,0,T3,P2,T3,P1)) return;

   ObjectSetInteger(0,pref+Name,OBJPROP_LEVELCOLOR,ColorFibo);
   ObjectSetInteger(0,pref+Name,OBJPROP_LEVELSTYLE,FiboStyle);
   ObjectSetInteger(0,pref+Name,OBJPROP_WIDTH,2);
   ObjectSetInteger(0,pref+Name,OBJPROP_BACK,0);
   ObjectSetInteger(0,pref+Name,OBJPROP_SELECTABLE,0);
   ObjectSetInteger(0,pref+Name,OBJPROP_SELECTED,0);
   ObjectSetInteger(0,pref+Name,OBJPROP_RAY_RIGHT,1);
   ObjectSetInteger(0,pref+Name,OBJPROP_HIDDEN,0);
   ObjectSetInteger(0,pref+Name,OBJPROP_LEVELS,7);
  
   ObjectSet(pref+Name,OBJPROP_FIRSTLEVEL+0,0.000);
   ObjectSet(pref+Name,OBJPROP_FIRSTLEVEL+1,0.35);
   ObjectSet(pref+Name,OBJPROP_FIRSTLEVEL+2,0.500);
   ObjectSet(pref+Name,OBJPROP_FIRSTLEVEL+3,0.65);
   ObjectSet(pref+Name,OBJPROP_FIRSTLEVEL+4,1.000);
   ObjectSet(pref+Name,OBJPROP_FIRSTLEVEL+5,1.618);
   ObjectSet(pref+Name,OBJPROP_FIRSTLEVEL+6,-.618);
   
   for (int x=0; x<7; x++) {
      ObjectSetFiboDescription(pref+Name,x,DoubleToStr(ObjectGet(pref+Name,OBJPROP_FIRSTLEVEL+x)*100,1)+"   %$");
   }
}